/*----------------------------------------------------------------------*/
/*		mmtimerf.c		multi-media timer via function demo				*/
/*																		*/
/*		Jeff Reid		09JUL03	 16:30									*/
/*----------------------------------------------------------------------*/
#include <windows.h> 
#include <stdio.h>
#include <mmsystem.h>

#pragma comment(lib, "winmm.lib")		/* include winmm.lib */

/*----------------------------------------------------------------------*/
/*		data															*/
/*----------------------------------------------------------------------*/
static TIMECAPS sTimeCaps;				/* min and max timer values */
static MMRESULT mmrTimerId;				/* timer id */
static DWORD	dwTicks;				/* tick counter */

/*----------------------------------------------------------------------*/
/*		code															*/
/*----------------------------------------------------------------------*/
void CALLBACK TimerFunction(UINT, UINT, DWORD, DWORD, DWORD);

/*----------------------------------------------------------------------*/
/*		main															*/
/*----------------------------------------------------------------------*/
DWORD main(DWORD argc, BYTE **argv)
{
/*										** get min and max period */
	timeGetDevCaps(&sTimeCaps, sizeof(sTimeCaps));
	if(sTimeCaps.wPeriodMin != 1){
		printf("1 ms resolution not allowed\n");
		goto exit1;}

	timeBeginPeriod(1);					/* set period to 1ms */

/*										** create 1ms timer to call function */
	mmrTimerId = timeSetEvent(1, 1, TimerFunction, 0, TIME_PERIODIC);
	if(mmrTimerId == (MMRESULT)0){
		printf("Failed to generate multimedia timer.\n");
		goto exit0;}

    Sleep(1000);						/* sleep and display ticks */
	printf("# ticks = %ld\n", dwTicks);
    Sleep(1000);
	printf("# ticks = %ld\n", dwTicks);
    Sleep(1000);
	printf("# ticks = %ld\n", dwTicks);
    Sleep(1000);
	printf("# ticks = %ld\n", dwTicks);
    Sleep(1000);
	printf("# ticks = %ld\n", dwTicks);

	timeKillEvent(mmrTimerId);			/* stop the timer */


exit0:
	timeEndPeriod(1);					/* restore resolution to default */
exit1:
	return(0);
}

/*----------------------------------------------------------------------*/
/*		TimerFunction		increments dwTicks 							*/
/*----------------------------------------------------------------------*/
void CALLBACK TimerFunction(UINT uTimerID, UINT uMsg,
						DWORD dwUser, DWORD dw1, DWORD dw2)
{
	dwTicks += 1;
}
